// HMIRotateDupSetDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "HMIRotateDupSetDlg.h"
#include "VisioDrawDoc.h"
#include "VisioDrawView.h"
#include "registry.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHMIRotateDupSetDlg dialog


CHMIRotateDupSetDlg::CHMIRotateDupSetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHMIRotateDupSetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHMIRotateDupSetDlg)
	m_nRows = 10;
	m_bTextRotate = TRUE;
	m_nTotalAngle = 3600;
	//}}AFX_DATA_INIT
	strMoveObj =_T("");
	DWORD nTempIndex = 0;
	DWORD nTempIndex1 = 0;
	CString strImage = _T("");
	CReg reg;
	if (reg.Open (HKEY_CURRENT_USER, REG_EDITPAD_IDE, KEY_READ))
    {
		reg.LoadNumber(_T ("Dup rotate rows"), &nTempIndex);
		reg.LoadNumber(_T ("total rotate angle"), &nTempIndex1);
		m_nRows = (int)nTempIndex;
		m_nTotalAngle =(int)nTempIndex1;
		
    }
	reg.Close ();
//	EnableVisualManagerStyle(TRUE, TRUE);
	m_crBK = RGB(255,255,255);
	m_crFG = RGB(255,255,255);
	m_bEnable = TRUE;
}


void CHMIRotateDupSetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHMIRotateDupSetDlg)
	DDX_Control(pDX, IDC_SPIN_ROWS, m_spinrow);
	DDX_Text(pDX, IDC_EDIT_ROWS, m_nRows);
	DDV_MinMaxInt(pDX, m_nRows, 3, 200);
	DDX_Check(pDX, IDC_CHECK_ROTATE, m_bTextRotate);
	DDX_Text(pDX, IDC_EDIT_COLS, m_nTotalAngle);
	DDV_MinMaxInt(pDX, m_nTotalAngle, 0, 3600);
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_FO_FORM_COLOR, m_btnColor);
	DDX_ColorDropDown(pDX, IDC_FO_FORM_COLOR, m_crFG);
	DDX_Control(pDX, IDC_FO_PAGE_BACKGROUND, m_btnBackground);
	DDX_ColorDropDown(pDX, IDC_FO_PAGE_BACKGROUND, m_crBK);
}


BEGIN_MESSAGE_MAP(CHMIRotateDupSetDlg, CDialog)
	//{{AFX_MSG_MAP(CHMIRotateDupSetDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHMIRotateDupSetDlg message handlers

BOOL CHMIRotateDupSetDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	GetDlgItem(IDC_MB_OBJECT_COMBO)->SetFont(&gfxData.fontBold);
	CComboBox *pBox = (CComboBox *)GetDlgItem(IDC_MB_OBJECT_COMBO);
	m_spinrow.SetBase(10);
	m_spinrow.SetRange(3,200);
	m_spinrow.SetPos(m_nRows);

	m_btnColor.GetDrawImpl().SetHeaderBarState(FOPDrawControlPanel::HeaderBarTwo);
	m_btnColor.GetDrawImpl().SetAutomaticColor(m_crFG);
	
	m_btnBackground.GetDrawImpl().SetHeaderBarState(FOPDrawControlPanel::HeaderBarTwo);
	m_btnBackground.GetDrawImpl().SetAutomaticColor(m_crBK);

	if(!m_bEnable)
	{
		m_btnColor.EnableWindow(FALSE);
		m_btnBackground.EnableWindow(FALSE);
	}

	pBox->AddString(_T(""));
	// TODO: Add extra initialization here
	CView* pVTemp =(CView*)FOGetActiveView();
	if(NULL != pVTemp)
	{
		if(pVTemp->IsKindOf(RUNTIME_CLASS(CVisioDrawView)))
		{
			CVisioDrawView *pView = (CVisioDrawView *)(pVTemp);
			int nCount = 0;
			CFODrawShape *pObj = NULL;
			int xy = 0;
			for(xy = 0; xy < pView->GetCurrentModel()->GetShapes()->Count(); xy ++)
			{
				pObj = (CFODrawShape *)pView->GetCurrentModel()->GetShapes()->GetObject(xy);
				if((pObj->GetType() != FO_COMP_MOVEPATH_SHAPE))
				{
					CString title;
					title = pObj->GetKeyId1();
					if(!title.IsEmpty())
						pBox->AddString(title);
				}
			}
		}
	}
	pBox->SelectString(-1,strMoveObj);

	SetTimer(1000,500, NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CHMIRotateDupSetDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData();
	CComboBox *pBox = (CComboBox *)GetDlgItem(IDC_MB_OBJECT_COMBO);
	int nCur = pBox->GetCurSel();
	if(nCur >=0)
	{	
		pBox->GetLBText(nCur,strMoveObj);
	}

	if(strMoveObj.IsEmpty())
	{
		
		pBox->SetFocus();
		return;
	}

	CReg reg;
	if (reg.Create (HKEY_CURRENT_USER, REG_EDITPAD_IDE, KEY_WRITE))
    {
		VERIFY (reg.SaveNumber (_T ("Dup rotate rows"), (DWORD)m_nRows));
		VERIFY (reg.SaveNumber (_T ("total rotate angle"), (DWORD)m_nTotalAngle));
		
		    }
	reg.Close ();
	CDialog::OnOK();
}



void CHMIRotateDupSetDlg::OnTimer(UINT_PTR nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(1000 == nIDEvent)
	{
		CEdit *pBox = (CEdit *)GetDlgItem(IDC_EDIT_ROWS);
		pBox->SetFocus();
		pBox->SetSel((DWORD) MAKELONG(0,-1));
		
		KillTimer(1000);
	}
	CDialog::OnTimer(nIDEvent);
}
